#include <stdio.h>
#include <comedilib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <errno.h>

void help(void)
{
	fprintf(stderr,"chart <channel number> [output file]\n");
	exit(0);
}

char line[]="================================================================================";

int main(int argc,char *argv[])
{
	int data,chan;
	int n;
	double voltage;
	int r,it;
	int outf=0;
	FILE *out;
	int val,flags;
	
	if(argc<2 || argc>3)help();

	if(!sscanf(argv[1],"%d",&chan))help();

	it=open("/dev/comedi0",O_RDWR);
	if(it<0){
		perror("/dev/comedi0");
		exit(0);
	}

	comedi_getparam(it,chan,COMEDI_IO,&flags,&val);
	if(!(val&COMEDI_IO_INPUT)){
		fprintf(stderr,"not input channel\n");
		exit(0);
	}
	
	if(argc>2){
		outf=1;
		out=fopen(argv[2],"w");
		if(!out){
			fprintf(stderr,"cannot open %s\n",argv[2]);
			exit(1);
		}
	}

	while(1){
		r=comedi_get(it,chan,&data);
		if(r<0)printf("ioctl errno=%d\n",errno);

		/*voltage=ch.zero+ch.delta*data;*/
		voltage=0+1*data;
		n=(data+2048)/(4096/72-1);
		printf("%5.2f|%-72.*s|\n",voltage,n,line);
/*
		printf("%d %d %u.%06d\n",sample.chan,sample.data,
			sample.time.tv_sec,sample.time.tv_usec);
*/
		usleep(100000);
	}
	
	return 0;
}



