#include <stdio.h>
#include <comedilib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <errno.h>

void help(void)
{
	fprintf(stderr,"mtrig [-f /dev/comediN]\n");
	exit(0);
}


int main(int argc,char *argv[])
{
	int it;
	char *fn=NULL;
	int i;
	int r;
	int chanlist[]={0,1,2,3};
	comedi_sample s[40];
	comedi_mtrig mtrig;

	for(i=1;i<argc;i++){
		if(!strcmp(argv[i],"-f")){
			i++;
			if(i<argc){
				fn=argv[i];
				continue;
			}else help();
		}
		else help();
	}
	if(!fn)fn="/dev/comedi0";

	it=open(fn,O_RDWR);
	if(it<0){
		perror(fn);
		exit(0);
	}

	mtrig.io=COMEDI_IO_INPUT;
	
	mtrig.n1=4;
	mtrig.trigsrc1=COMEDI_TRIGCLK;
	mtrig.trigvar1=1999;
	
	mtrig.chanlist=chanlist;
	
	mtrig.n2=10;
	mtrig.trigsrc2=COMEDI_TRIGCLK;
	mtrig.trigvar2=19999;
	
	r=ioctl(it,COMEDI_MTRIG,&mtrig);
	if(r<0)perror("error triggering device");
	
	r=read(it,s,40*sizeof(comedi_sample));
	for(i=0;i<40;i++){
		printf("%d\n",s[i].data);
	}
	
	return 0;
}



