#include <stdio.h>
#include <comedilib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <errno.h>

void help(void)
{
	fprintf(stderr,"outp [-r range] [-f /dev/comediN] <channel number> <data>\n");
	exit(0);
}

int main(int argc,char *argv[])
{
	int data,chan;
	int it;
	char *fn=NULL;
	int i,n=0;
	int ir=-1;

	for(i=1;i<argc;i++){
		if(!strcmp(argv[i],"-f")){
			i++;
			if(i<argc){
				fn=argv[i];
				continue;
			}else help();
		}
		if(!strcmp(argv[i],"-r")){
			i++;
			if(i<argc){
				if(sscanf(argv[i],"%d",&ir))
					continue;
			}
			help();
		}
		if(n==0){
			if(!sscanf(argv[i],"%d",&chan))help();
			n=1;
			continue;
		}
		if(n==1){
			if(!sscanf(argv[i],"%d",&data))help();
			n=2;
			continue;
		}
			
	}
	if(!fn)fn="/dev/comedi0";

	it=open(fn,O_RDWR);
	if(it<0){
		perror(fn);
		exit(0);
	}

	if(ir>=0){
		if(comedi_setparam(it,chan,COMEDI_RANGE,ir)<0)
			perror("error changing range");
	}
	if(comedi_put(it,chan,data)<0)perror("error triggering device");
	
	return 0;
}

